import { Block, Popup, PopupContent, PopupHeader, useFormContext } from '@ensi-platform/core-components';
import { Row } from '@tanstack/react-table';
import { isEmpty } from 'lodash';
import { useRouter } from 'next/router';
import { useCallback, useMemo, useState } from 'react';

import { Product, ProductFilter, useProducts, useProductsMeta, useProductsTypes } from '@api/catalog';

import { useError } from '@context/modal';

import LoadWrapper from '@controls/LoadWrapper';

import AutoFilters from '@components/AutoFilters';
import Table, { useSorting, useTable } from '@components/Table';
import { getSelectColumn, getSettingsColumn } from '@components/Table/columns';
import { TableEmpty, TableFooter, TableHeader } from '@components/Table/components';

import { Button, typography } from '@scripts/gds';
import { declOfNum, getTotal, getTotalPages } from '@scripts/helpers';
import { useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

import PlusIcon from '@icons/plus.svg';

interface ConvertedProductData extends Omit<Product, 'type'> {
    type: number | string;
    customListLink: string;
}

export default function AddProductGroupItemsPopup({
    isOpen = false,
    onRequestClose,
    maxRowSelect = 0,
    isMainProduct = false,
}: {
    isOpen: boolean;
    onRequestClose: () => void;
    maxRowSelect?: number;
    isMainProduct?: boolean;
}) {
    const { query, push, pathname } = useRouter();

    const [selectedFilter, setSelectedFilter] = useState<Partial<ProductFilter>>({});

    const { watch, setValue } = useFormContext<{
        main_product: Product | null;
        products: Product[];
    }>();

    const [main_product, productsForm] = watch(['main_product', 'products']);

    const { data: metaData, isFetching: isLoading, error } = useProductsMeta(isOpen);

    useError(error);

    const meta = useMemo(
        () =>
            !isMainProduct && metaData?.data
                ? {
                      ...metaData.data,
                      default_filter: metaData.data.default_filter.filter(f => f !== 'category_id'),
                      fields: metaData.data.fields.filter(f => f.code !== 'category_id'),
                  }
                : metaData?.data,
        [isMainProduct, metaData?.data]
    );

    const {
        metaField,
        values,
        filtersActive,
        URLHelper,
        reset,
        searchRequestFilter,
        emptyInitialValues,
        clearInitialValue,
        codesToSortKeys,
        searchRequestIncludes,
    } = useAutoFilters(meta, { isSaveToUrl: false });

    const pageKey = 'new-products-groups';
    const [{ backendSorting }, sortingPlugin] = useSorting<Product>(pageKey, meta?.fields);

    const { activePage, itemsPerPageCount, setItemsPerPageCount } = useTableList({
        defaultSort: metaData?.data.default_sort,
        codesToSortKeys,
        pageKey,
    });

    const autoGeneratedColumns = useAutoColumns(meta);

    const columns = useMemo(
        () => [
            getSelectColumn(maxRowSelect, 'new-products-groups'),
            ...autoGeneratedColumns,
            getSettingsColumn({ columnsToDisable: [], visibleColumns: meta?.default_list }),
        ],
        [autoGeneratedColumns, maxRowSelect, meta?.default_list]
    );

    const filtersProduct = useMemo(
        () =>
            isMainProduct
                ? {
                      ...searchRequestFilter,
                      has_product_groups: false,
                      category_has_is_gluing: true,
                  }
                : {
                      ...searchRequestFilter,
                      has_product_groups: false,
                      category_ids: main_product?.category_ids,
                  },
        [isMainProduct, main_product, searchRequestFilter]
    );

    const {
        data: products,
        isFetching: isProductsLoading,
        error: productsError,
    } = useProducts(
        {
            filter: filtersProduct,
            sort: backendSorting,
            include: ['category', ...searchRequestIncludes],
            pagination: { type: 'offset', limit: itemsPerPageCount, offset: (activePage - 1) * itemsPerPageCount },
        },
        Boolean(meta) && !!backendSorting && isOpen
    );

    const productsData = useMemo(() => products?.data, [products?.data]);

    useError(productsError);

    const { data: apiTypes } = useProductsTypes(isOpen);

    const convertProductData = useMemo(
        () =>
            productsData
                ?.map(item => ({
                    ...item,
                    id: item?.id,
                    type: apiTypes?.data.find(elem => elem.id === item.type)?.name || '-',
                    customListLink: '/products/catalog',
                    isClient: true,
                }))
                .filter(product => !productsForm.find(p => p.id === product.id)),
        [apiTypes?.data, productsData, productsForm]
    );

    const productsTableData = useAutoTableData<ConvertedProductData>(convertProductData, metaField);

    const total = getTotal(products);
    const totalPages = getTotalPages(products, itemsPerPageCount);

    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total, shallow: true, pageKey });

    const table = useTable(
        {
            data: productsTableData,
            columns,
            meta: {
                tableKey: pageKey,
            },
        },
        [sortingPlugin]
    );

    const renderHeader = useCallback(
        (selectedRows: Row<Product>[]) => (
            <TableHeader>
                <div css={{ display: 'flex', justifyContent: 'space-between', width: '100%', padding: '0' }}>
                    <p css={{ lineHeight: '32px', ...typography('bodySm') }}>
                        Найдено {`${total} ${declOfNum(total, ['товар', 'товара', 'товаров'])}`}
                    </p>

                    {selectedRows?.length > 0 ? (
                        <Button
                            Icon={PlusIcon}
                            theme="primary"
                            type="submit"
                            onClick={() => {
                                if (isMainProduct) {
                                    const foundProduct = convertProductData?.find(
                                        ({ id }) => id === selectedRows[0].original.id
                                    );
                                    if (foundProduct) {
                                        const typeId = apiTypes?.data.find(
                                            elem => elem.name === foundProduct?.type
                                        )?.id;
                                        const updatedProduct: Product = {
                                            ...foundProduct,
                                            type: Number(typeId),
                                        };
                                        setValue('main_product', updatedProduct, {
                                            shouldDirty: true,
                                            shouldTouch: true,
                                            shouldValidate: true,
                                        });
                                    }
                                } else {
                                    setValue('products', productsForm.concat(selectedRows.map(row => row.original)), {
                                        shouldDirty: true,
                                        shouldTouch: true,
                                        shouldValidate: true,
                                    });
                                }

                                table.reset();
                                onRequestClose();
                            }}
                        >
                            Добавить{' '}
                            {`${selectedRows?.length} ${declOfNum(selectedRows?.length, [
                                'товар',
                                'товара',
                                'товаров',
                            ])}`}
                        </Button>
                    ) : null}
                </div>
            </TableHeader>
        ),
        [onRequestClose, productsForm, setValue, total, isMainProduct, convertProductData]
    );

    const resetFilters = () => {
        reset();
        setSelectedFilter({});
        table.reset();
        push({ pathname, query: { pid: query.pid } });
    };

    return (
        <Popup open={isOpen} onClose={onRequestClose} size="screen_lg" innerScroll onUnmount={() => resetFilters()}>
            <PopupHeader title="Выберите товары для добавления" />
            <PopupContent>
                <LoadWrapper isLoading={isLoading || isProductsLoading}>
                    <AutoFilters
                        initialValues={values}
                        emptyInitialValues={emptyInitialValues}
                        onSubmit={v => {
                            URLHelper(v);
                            push({ pathname, query: { pid: query.pid, page: 1 } });
                        }}
                        onResetFilters={resetFilters}
                        filtersActive={filtersActive}
                        meta={meta}
                        clearInitialValue={clearInitialValue}
                    />

                    <Block>
                        <Block.Body>
                            {renderHeader(table.getSelectedRowModel().flatRows)}
                            <Table instance={table} />

                            {convertProductData?.length === 0 ? (
                                <TableEmpty
                                    filtersActive={!isEmpty(selectedFilter)}
                                    onResetFilters={() => {
                                        reset();
                                        setSelectedFilter({});
                                    }}
                                    titleWithFilters="Товары не найдены"
                                    titleWithoutFilters="Товаров нет"
                                />
                            ) : (
                                <TableFooter
                                    pages={totalPages}
                                    itemsPerPageCount={itemsPerPageCount}
                                    setItemsPerPageCount={setItemsPerPageCount}
                                    pageKey={pageKey}
                                />
                            )}
                        </Block.Body>
                    </Block>
                </LoadWrapper>
            </PopupContent>
        </Popup>
    );
}
